#include <stdio.h>
#include "mtacrypt.h"

// compile with: cl mtacrypt-example.c mtacrypt.lib (tested with vc++ 6.0)
// example usage: mtacrypt-example.exe adc24cb3e8976e18ef88b80d97f6e429
// if it works it should output: "hello there!" (using the above example)

int dehex(char *data)
{
	char *cp;
	char ch;
	unsigned int i = 0, by;

	cp = data;

	while((*cp) && (i < 32))
	{
		ch = toupper(*cp++);	// process a hexadecimal digit

		if(ch >= '0' && ch <= '9')
			by = (by << 4) + ch - '0';
		else if(ch >= 'A' && ch <= 'F')
			by = (by << 4) + ch - 'A' + 10;
		else
		{
			return 1;
		}

		// store a key byte for each pair of hexadecimal digits
		if(i++ & 1)
		{
			data[i / 2 - 1] = by & 0xff;
		}
	}

	return 0;
}

int main(int argc, char *argv[])
{
	char buffer[33];

	memcpy((char*)&buffer, argv[1], 32);

	buffer[33] = 0;

	if (dehex(buffer))
	{
		printf("baka!\n");
		return 1;
	}

	decryptfp(buffer, 16, 1);

	printf("%s", (char*)&buffer);

	return 0;
}
