on *:START: {
  unset %mta.host
  unset %mta.port
  set %connecting $false
  set %connected $false

  echo 8 -s To connect type /mta ip[:port] nick [pass]
  echo 8 -s To disconnect type /mta.disconnect
  echo 8 -s To send chat type /mta.say
  echo 8 -s To get a player list type /mta.list
  echo 8 -s I know, the code is hackish, it was put together as an example from parts of [DRuG]Trix's mIRC MTA Client (NO! ITS NOT PUBLIC! DONT EVEN ASK!)
}

; /mta ip[:port] nick [pass]
alias mta {
  if (!$window(@Debug)) { window -k0n @Debug }

  .write -c mta.ini

  set %mta.host $gettok($1,1,58)
  set %mta.port $iif($gettok($1,2,58) != $null, $gettok($1,2,58), 2003)
  set %mta.nick $2
  set %mta.pass $3

  echo 9 -s Connecting...
  set %connecting $true
  set %connected $false

  bunset &s
  bset &s 1 $encryptfpc(255 0 1 50 0 80 22 128 237 $explode(%mta.nick) 124 $explode(%mta.pass) 0)

  sockclose mta
  sockudp -k mta %mta.host %mta.port &s

  .timerTO 1 10 mta.to
}

alias mta.senddata {
  if (%connected == $false) {
    return
  }

  bunset &s
  bset &s 1 $encryptpc($1-)
  sockudp -k mta %mta.host %mta.port &s
}

alias mta.to {
  mta.disconnect Connection timed out.
}

alias mta.disconnect {
  if (($sock(mta)) && (%mta.host) && (%mta.port)) { mta.senddata 1 2 0 }

  echo 9 -s $iif($1- != $null, $1-, Disconnected.) $iif($sock(mta), Sent: $bytes($sock(mta).sent,3).suf $chr(124) Recieved: $bytes($sock(mta).rcvd,3).suf, $null)
  sockclose mta

  unset %mta.host
  unset %mta.port
  set %connecting $false
  set %connected $false
}

alias mta.game { return $iif(%mta.game >= 3,GTA:3,GTA:VC) }
alias mta.name { return $readini(mta.ini,$1,nick) }
alias mta.players !return $ini($scriptdir $+ mta.ini,0)
alias mta.kills !return $readini($scriptdir $+ mta.ini,$1,kills)

alias _getchar {
  var %a = 1
  bset &z 1 $1-
  while (%a <= $numtok($1-,32)) {
    if ($bfind(&z,%a,7) != 0) var %b = $v1
    inc %a
  }
  return %b
}

alias mta.list {
  if (%connected == $false) {
    return
  }

  var %a = 1,%b,%c,%d = $scriptdir $+ mta.ini
  while (%a <= $mta.players) {
    if (!$readini(%d,$ini(%d,%a),nick)) !remini $+(",%d,") $ini(%d,%a)
    %b = $ini(%d,%a)
    echo 8 -s ID: %b Kills: $mta.kills(%b) Name: $mta.name(%b)
    inc %a
  }
}

alias mta.say {
  if (%connected == $false) {
    return
  }

  mta.senddata 255 0 3 1 $explode($1-) 0
}

on *:udpread:mta:{
  bunset &t
  sockread &t
  .timerTO 1 10 mta.to

  bunset &a

  if (%connecting == $true) {
    set %connecting $false
    set %connected $true

    var %i = $bvar(&t,0), %m = 1

    while (%i >= 1) {
      if (%m == 1) {
        bset &a %m $decryptfpc($bvar(&t,%m,128))
      }
      else {
        bset &a %m $decryptfpc(- $+ $bvar(&t,%m,128))
      }
      dec %i 128
      inc %m 128
    }
  }
  else {
    var %i = $bvar(&t,0), %m = 1

    while (%i >= 1) {
      bset &a %m $decryptpc($bvar(&t,%m,126))
      dec %i 128
      inc %m 128
    }
  }

  if ($bvar(&a,3) == 1) {
    var %a
    %mta.id = $bvar(&a,7)
    %mta.game = $bvar(&a,5)
    echo 9 -s Connected.
    echo 9 -s Server Map: $mta.game
    echo 9 -s Server Game Mode: $mta.mode
    echo 9 -s Server Name: $bvar(&a,40,50).text
    echo 9 -s Server Max Players: $bvar(&a,8)
    echo 9 -s MOTD Url: $iif($bvar(&a,90,255).text,$ifmatch,http://www.mtavc.com/clientwelcomes/clientwelcome050.rtf)
    if ($mta.game == GTA:3) echo 9 -s Submode: $gettok(Normal;Unknown;Van Heist;GTA;Speed;Ransack;Scramble start;Scramble,$calc($bvar(&a,6)+1),59)
    echo 9 -s Weather: $iif($mta.game == GTA:3,Disabled,$gettok(Sun;Cloud;Rain;Fog,$calc($bvar(&a,11)+1),59))

    writeini -n mta.ini $bvar(&a,7) kills 0
    writeini -n mta.ini $bvar(&a,7) nick %mta.nick
    if (%mta.game >= 3) {
      ; GTA3
      if ($bfind(&a,345,7)) {
        !bcopy -c &a 1 &a 345 $_getchar($bvar(&a,345,$bvar(&a,0)))
        :1
        !bcopy -c &c 1 &a 8 $calc($bfind(&a,8,7)-8)
        var %a = writeini mta.ini $bvar(&a,1)
        %a nick $bvar(&c,1,$bvar(&c,0)).text
        %a deaths 0
        %a kills 0
        %a online $ticks
        %a idle $ticks
        %a status 0
        %a kills $iif($bvar(&a,3) <= 127,$a16int2numr($bvar(&a,2,2)),$calc(-256+$bvar(&a,2)-(255-$bvar(&a,3))*256))
        %a money $a32int2numr($bvar(&a,4,4))
        if ($bvar(&a,$calc($bvar(&c,0)+9)) != $null) {
          !bcopy -c &a 1 &a $calc($bvar(&c,0)+9) -1
          !goto 1
        }
      }
    }
    elseif (%mta.game < 3) {
      ; VC
      if ($bfind(&a,345,7)) {
        !bcopy -c &a 1 &a 345 $_getchar($bvar(&a,345,$bvar(&a,0)))
        :2
        !bcopy -c &c 1 &a 4 $calc($bfind(&a,4,7)-4)
        var %a = .writeini mta.ini $bvar(&a,1)
        %a nick $bvar(&c,1,$bvar(&c,0)).text
        %a deaths 0
        %a kills 0
        %a online $ticks
        %a idle $ticks
        %a status 0
        %a kills $iif($bvar(&a,3) <= 127,$a16int2numr($bvar(&a,2,2)),$calc(-256+$bvar(&a,2)-(255-$bvar(&a,3))*256))
        %a money 0
        if ($bvar(&a,$calc($bvar(&c,0)+5)) != $null) {
          !bcopy -c &a 1 &a $calc($bvar(&c,0)+5) -1
          !goto 2
        }
      }
    }
    mta.list
  }
  elseif ($bvar(&a,3) == 36) { !writeini mta.ini $bvar(&a,4) money $a16int2numr($bvar(&a,5,2)) }
  elseif ($bvar(&a,3) == 3) {
    var %text = $bvar(&a,6,$bvar(&a,0)).text
    if ($bvar(&a,5) == 3) {
      if ($left(%text,3) == /me) { echo 6 -s * Admin $bvar(&a,10,$bvar(&a,0)).text }
      elseif ($left(%text,5) == /slap) { echo 6 -s * Admin slaps $bvar(&a,11,$bvar(&a,0)).text }
      elseif ($left(%text,4) == /msg) { 
        echo 6 -s PM from Admin $+ : $bvar(&a,10,$bvar(&a,0)).text
        mta.senddata 3 $mta.getid(%mta.nick) 1 /msgr $bvar(&a,10,$bvar(&a,0)).text 0
      }
      else { echo 13 -s < $+ %text $+ > }
    }
    elseif ($left(%text,5) == /slap) echo 6 -s * $mta.name($bvar(&a,4)) slaps $bvar(&a,11,$bvar(&a,0)).text
    elseif ($left(%text,3) == /me) echo 6 -s * $mta.name($bvar(&a,4)) $bvar(&a,10,$bvar(&a,0)).text
    elseif ($left(%text,4) == /msg) {
      if ($dialog(pm. $+ $bvar(&a,4))) mta.pmlog $bvar(&a,4) $bvar(&a,11,$bvar(&a,0)).text 
      if ($bvar(&a,4) == $mta.getid(%mta.nick)) { echo 6 -s PM sent: $bvar(&a,11,$bvar(&a,0)).text | halt }
      echo 6 -s PM from $mta.name($bvar(&a,4)) $+ : $bvar(&a,11,$bvar(&a,0)).text
      mta.senddata 255 0 3 $mta.getid(%mta.nick) 1 /msgr $bvar(&a,11,$bvar(&a,0)).text 0
    }
    else {
      echo $iif($mta.name($bvar(&a,4)) != %mta.nick, $iif($bvar(&a,5) == 1,11,8), 15) -s $mta.name($bvar(&a,4)) $+ : %text
    }
  }
  elseif ($bvar(&a,3) == 4) {
    mta.senddata 255 255 5
  }
  elseif ($bvar(&a,3) == 6) {
    .timerTO off
    mta.disconnect $gettok(Nick already in use;You are banned;IP already connected;You have been kicked;Incorrect password;Server shutdown;Incompatible version;Server is full;Client CRC check mismatch;Client CRC check timeout;Nick not permitted;Admin+ disabled;Join Flood Prevention,$calc($bvar(&a,4)+1),59)
  }
  elseif ($bvar(&a,3) == 8) {
    writeini mta.ini $bvar(&a,4) nick $bvar(&a,5,$bvar(&a,0)).text
    writeini mta.ini $bvar(&a,4) kills 0
    writeini mta.ini $bvar(&a,4) online $ticks
    echo 10 -s $bvar(&a,5,$bvar(&a,0)).text has joined the game.
  }
  elseif ($bvar(&a,3) == 9) {
    var %a
    if ($dialog(mta.statistics)) && (%stat.id == $bvar(&a,5)) { .timerstat off | dialog -x mta.statistics }
    echo 10 -s $mta.name($bvar(&a,5)) $gettok(has left the game.;has been kicked from the game.;timed out.;kicked. (Flooding);parts. (Suspected trainer usage);parts. (CRC mismatch);parts. (CRC timeout);kicked. (Banned),$calc($bvar(&a,4)+1),59)
    remini mta.ini $bvar(&a,5)
  }
  elseif ($bvar(&a,3) == 11) {
    if ($bvar(&a,4) == $bvar(&a,5)) echo 5 -s $mta.name($bvar(&a,5)) killed himself  ( $+ $mta.weapon($bvar(&a,6)) $+ )
    elseif ($bvar(&a,5) >= 255) echo 5 -s $mta.name($bvar(&a,4)) $iif($bvar(&a,6) == 43,drowned,died $iif($mta.weapon($bvar(&a,6)),( $+ $mta.weapon($bvar(&a,6)) $+ ), ))
    else { echo 5 -s $mta.name($bvar(&a,5)) killed $mta.name($bvar(&a,4)) ( $+ $mta.weapon($bvar(&a,6)) $+ ) }
  }
  elseif ($bvar(&a,3) == 25) {
    mta.senddata 5 0 25 80 22 128 237
  }
  elseif ($bvar(&a,3) == 33) { if ($mta.game != GTA:3) { echo 7 -s Game Changed Weather: $gettok(Sun;Cloud;Rain;Fog,$calc($bvar(&a,4)+1),59)) } }
  elseif ($bvar(&a,3) == 30) { echo 7 -s Scores Reset }
  elseif ($bvar(&a,3) == 34) { echo 7 -s Money Reset }
  elseif ($bvar(&a,3) == 35) {
    echo 7 -s Admin Changed Weather: $gettok(Sun;Cloud;Rain;Fog,$calc($bvar(&a,4) +1),59)
  }

  echo 3 @Debug $bvar(&a,1,300)
}
