alias decryptfp {
  return $dll(mtacrypt-mirc.dll, decryptfp, $remove($1-,$chr(32)))
}

alias encryptfp {
  return $dll(mtacrypt-mirc.dll, encryptfp, $remove($1-,$chr(32)))
}

alias decryptp {
  return $dll(mtacrypt-mirc.dll, decryptp, $remove($1-,$chr(32)))
}

alias encryptp {
  return $dll(mtacrypt-mirc.dll, encryptp, $remove($1-,$chr(32))
}

alias decryptfpc {
  if ($left($1-,1) == -) {
    return $hextoc($dll(mtacrypt-mirc.dll, decryptfp, - $+ $ctohex($right($1-,-1)))))
  }
  else {
    return $hextoc($dll(mtacrypt-mirc.dll, decryptfp, $ctohex($1-))))
  }
}

alias encryptfpc {
  return $hextoc($dll(mtacrypt-mirc.dll, encryptfp, $ctohex($1-))))
}

alias decryptpc {
  return $hextoc($dll(mtacrypt-mirc.dll, decryptp, $ctohex($1-))))
}

alias encryptpc {
  return $hextoc($dll(mtacrypt-mirc.dll, encryptp, $ctohex($1-))))
}

alias unhex {
  var %l 1, %r
  while (%l <= $len($1-)) {
    if (!$2) {
      if ($mid($1-,%l,2) != 20) %r = %r $+ $chr($base($mid($1-,%l,2),16,10))
      else %r = %r $chr($base($mid($1-,%l,2),16,10))
    }
    else %r = %r $+ $chr($base($mid($1-,%l,2),16,10))
    inc %l 2
  }
  return %r
}

alias hex {
  var %l 1, %r
  while (%l <= $len($1-)) {
    %r = %r $+ $base($asc($mid($1-,%l,1)),10,16,2)
    inc %l
  }
  return %r
}

alias hextoc {
  return $dll(mtacrypt-mirc.dll, hextoc, $remove($1-,$chr(32)))
}

alias ctohex {
  return $dll(mtacrypt-mirc.dll, ctohex, $1-)
}

alias float2num {
  return $dll(mtacrypt-mirc.dll, hextofloat, $ctohex($1-))
}

alias num2float {
  return $hextoc($dll(mtacrypt-mirc.dll, floattohex, $1-))
}

alias num2int32 {
  return $replace($longip($1),.,$chr(32))
}

alias a32int2num {
  return $longip($replace($1-,$chr(32),.))
}

alias num2int32r {
  return $replace($reverse32($longip($1)),.,$chr(32))
}

alias a32int2numr {
  return $longip($reverse32($replace($1-,$chr(32),.)))
}

alias num2int16 {
  return $gettok($replace($longip($1),.,$chr(32)),3-4,32)
}

alias a16int2num {
  return $longip($replace(0 0 $1-,$chr(32),.))
}

alias num2int16r {
  return $gettok($replace($reverse32($longip($1)),.,$chr(32)),1-2,32)
}

alias a16int2numr {
  return $longip($reverse32($replace($1- 0 0,$chr(32),.)))
}

alias num2int24 {
  return $gettok($replace($longip($1),.,$chr(32)),2-4,32)
}

alias a24int2num {
  return $longip($replace(0 $1-,$chr(32),.))
}

alias num2int24r {
  return $gettok($replace($reverse32($longip($1)),.,$chr(32)),1-3,32)
}

alias a24int2numr {
  return $longip($reverse32($replace($1- 0,$chr(32),.)))
}

alias num2int64r {
  var %tmp1 = $calc($1- % 2^32)
  var %tmp2 = $int($calc($1- / 2^32))
  return $replace($reverse32($longip(%tmp1)) $reverse32($longip(%tmp2)),.,$chr(32))
}

alias a64int2numr {
  var %tmp = $replace($1-,$chr(32),.)
  var %tmp1 = $reverse32($gettok(%tmp,1-4,46))
  var %tmp2 = $reverse32($gettok(%tmp,5-8,46))
  return $calc($longip(%tmp1) + ($longip(%tmp2) * 2^32))
}

alias num2int64 {
  var %tmp1 = $calc($1- % 2^32)
  var %tmp2 = $int($calc($1- / 2^32))
  return $replace($longip(%tmp2) $longip(%tmp1),.,$chr(32))
}

alias a64int2num {
  var %tmp = $replace($1-,$chr(32),.)
  var %tmp1 = $gettok(%tmp,1-4,46)
  var %tmp2 = $gettok(%tmp,5-8,46)
  return $calc($longip(%tmp2) + ($longip(%tmp1) * 2^32))
}

alias reverse32 {
  return $gettok($1,4,46) $+ . $+ $gettok($1,3,46) $+ . $+ $gettok($1,2,46) $+ . $+ $gettok($1,1,46)
}

alias explode {
  var %a = 1,%b
  while (%a <= $len($1-)) {
    %b = %b $asc($mid($1-,%a,1))
    inc %a
  }
  return %b
}

alias implode {
  var %l 1, %r
  while (%l <= $numtok($1-,32)) {
    if ($gettok($1-,%l,32) == 32) {
      inc %l 1
      %r = %r $chr($gettok($1-,%l,32))
      inc %l 1
    }
    else {
      %r = %r $+ $chr($gettok($1-,%l,32))
      inc %l 1
    }
  }
  return %r
}
